unit acRZDriver;

// written by @L.CHEMIST (Andrey A. Meshkov)
// http://maalchemist.narod.ru
// maalchemist@yandex.ru
// maalchemist@gmail.com

interface

uses
  Windows, acDriverTypes, acRZDriverTypes;

var
  RZDriver : TAC_Driver = (
    x64     : false;
    handle  : INVALID_HANDLE_VALUE;
    service : 0;
    drvname : '';
    drvpath : '';
  );

procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverQuery); register; overload;
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverIOQuery); register; overload;
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverCPQuery); register; overload;
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverCPQueries); register; overload;
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverLIQuery); register; overload;

procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverQuery); register; overload;
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverIOQuery); register; overload;
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverCPQuery); register; overload;
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverCPQueries); register; overload;
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverLIQuery); register; overload;

function  RZDriver_IOCTRL (var AQuery: TRZDriverQuery): Boolean; register; overload;
function  RZDriver_IOCTRL (var AQuery: TRZDriverIOQuery): Boolean; register; overload;
function  RZDriver_IOCTRL (var AQuery: TRZDriverCPQuery): Boolean; register; overload;
function  RZDriver_IOCTRL (var AQuery: TRZDriverCPQueries): Boolean; register; overload;
function  RZDriver_IOCTRL (var AQuery: TRZDriverLIQuery): Boolean; register; overload;

function  RZDriver_IOCTRL_(AIOCODE: DWORD; var AResult: Int64): Boolean; register; overload;

function  RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverQuery): Boolean; register; overload;
function  RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverIOQuery): Boolean; register; overload;
function  RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverCPQuery): Boolean; register; overload;
function  RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverCPQueries): Boolean; register; overload;
function  RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverLIQuery): Boolean; register; overload;

function  RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverQuery): Boolean; register; overload;
function  RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverIOQuery): Boolean; register; overload;
function  RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverCPQuery): Boolean; register; overload;
function  RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverCPQueries): Boolean; register; overload;
function  RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverLIQuery): Boolean; register; overload;

function  RZDriver_Open (const ARZDriver, ASuffix: string; var AReturnCode: Integer): Boolean; register;
procedure RZDriver_Close; register;

implementation

uses
  SysUtils, acDriverUtils;

{
}
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverQuery);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery.IOCODE := AIOCODE;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverIOQuery);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery.IOCODE := AIOCODE;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverCPQuery);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery.IOCODE := AIOCODE;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverCPQueries);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery[0].IOCODE := AIOCODE;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE: DWORD; var AQuery: TRZDriverLIQuery);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery.IOCODE := AIOCODE;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverQuery);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery.IOCODE := AIOCODE;
  AQuery.IODATA := AIODATA;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverIOQuery);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery.IOCODE := AIOCODE;
  AQuery.IODATA := AIODATA;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverCPQuery);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery.IOCODE := AIOCODE;
  AQuery.IODATA := AIODATA;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverCPQueries);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery[0].IOCODE := AIOCODE;
  AQuery[0].IODATA := AIODATA;
end;

{
}
procedure RZDriver_SetQuery (AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverLIQuery);
begin
  FillChar (AQuery, SizeOf (AQuery), 0);
  AQuery.IOCODE := AIOCODE;
  AQuery.IODATA := AIODATA;
end;

{
}
function RZDriver_IOCTRL_(AIOCODE: DWORD; var AResult: Int64): Boolean;
var
  Q : TRZDriverQuery;
begin
  AResult := 0;

  Q.IOCODE := AIOCODE;
  Q.RESULT := 0;
  Result := RZDriver_IOCTRL (Q);

  if Result then AResult := Q.RESULT;
end;

{
}
function RZDriver_IOCTRL (var AQuery: TRZDriverQuery): Boolean;
var
  B : DWORD;
begin
  Result := WriteFile (RZDriver.handle, AQuery, SizeOf(AQuery), B, nil);
end;

{
}
function RZDriver_IOCTRL (var AQuery: TRZDriverIOQuery): Boolean;
var
  B : DWORD;
begin
  Result := WriteFile (RZDriver.handle, AQuery, SizeOf(AQuery), B, nil);
end;

{
}
function RZDriver_IOCTRL (var AQuery: TRZDriverCPQuery): Boolean;
var
  B : DWORD;
begin
  Result := WriteFile (RZDriver.handle, AQuery, SizeOf(AQuery), B, nil);
end;

{
}
function RZDriver_IOCTRL (var AQuery: TRZDriverCPQueries): Boolean;
var
  B : DWORD;
begin
  Result := WriteFile (RZDriver.handle, AQuery, SizeOf(AQuery), B, nil);
end;

{
}
function RZDriver_IOCTRL (var AQuery: TRZDriverLIQuery): Boolean;
var
  B : DWORD;
begin
  Result := WriteFile (RZDriver.handle, AQuery, SizeOf(AQuery), B, nil);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverQuery): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverIOQuery): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverCPQuery): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverCPQueries): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE: DWORD; var AQuery: TRZDriverLIQuery): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverQuery): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AIODATA, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverIOQuery): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AIODATA, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverCPQuery): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AIODATA, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverCPQueries): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AIODATA, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
}
function RZDriver_IOCTRL_(AIOCODE, AIODATA: DWORD; var AQuery: TRZDriverLIQuery): Boolean;
begin
  RZDriver_SetQuery (AIOCODE, AIODATA, AQuery);
  Result := RZDriver_IOCTRL (AQuery);
end;

{
  driver = RZ32(64) + ASuffix
}
function RZDriver_Open (const ARZDriver, ASuffix: string; var AReturnCode: Integer): Boolean;
var
  VOSV          : TOSVersionInfoA;
  SRZDriver     : string;
  Sx32Driver    : string;
  Sx64Driver    : string;
  Sx32DriverSYS : string;
  Sx64DriverSYS : string;
begin
  Result := true;
  AReturnCode := 0;

  if RZDriver.handle <> INVALID_HANDLE_VALUE then begin
    AReturnCode := -1;
    Exit;
  end;

  SRZDriver := Trim (ARZDriver);
  if SRZDriver = '' then SRZDriver := Sx32Driver;

  Sx32Driver := 'RZ32' + ASuffix;
  Sx64Driver := 'RZ64' + ASuffix;
  Sx32DriverSYS := Sx32Driver + '.SYS';
  Sx64DriverSYS := Sx64Driver + '.SYS';

  RZDriver.x64 := false;

  // Windows XP x86 - 5/1/2600/2/
  // Windows XP x64 - 5/2/3790/2/

  VOSV.dwOSVersionInfoSize := SizeOf (TOSVersionInfoA);
  GetVersionExA (VOSV);

  if VOSV.dwPlatformID = VER_PLATFORM_WIN32_NT then begin
    Result := false;

    acDriverUtils.UninstallDriver (Sx32Driver);
    acDriverUtils.UninstallDriver (Sx64Driver);

    if (SRZDriver <> Sx32Driver) and (SRZDriver <> Sx64Driver) then begin
      // try 32-bit driver
      if not Result then begin
        acDriverUtils.OpenDriver (RZDriver, Sx32Driver, Sx32DriverSYS);
        Result := RZDriver.handle <> INVALID_HANDLE_VALUE;
      end;

      // try 64-bit driver
      if not Result then begin
        acDriverUtils.OpenDriver (RZDriver, Sx64Driver, Sx64DriverSYS);
        Result := RZDriver.handle <> INVALID_HANDLE_VALUE;
      end;
    end else begin
      // (SRZDriver = 'RZ32...') or (SRZDriver = 'RZ64...')

      acDriverUtils.OpenDriver (RZDriver, SRZDriver, SRZDriver + '.SYS');
      Result := RZDriver.handle <> INVALID_HANDLE_VALUE;

      if not Result then begin
        // try 32-bit driver
        if (not Result) and (SRZDriver <> Sx32Driver) then begin
          acDriverUtils.OpenDriver (RZDriver, Sx32Driver, Sx32DriverSYS);
          Result := RZDriver.handle <> INVALID_HANDLE_VALUE;
        end;

        // try 64-bit driver
        if (not Result) and (SRZDriver <> Sx64Driver) then begin
          acDriverUtils.OpenDriver (RZDriver, Sx64Driver, Sx64DriverSYS);
          Result := RZDriver.handle <> INVALID_HANDLE_VALUE;
        end;
      end;
    end;

    RZDriver.x64 := AnsiSameText (RZDriver.drvname, Sx64Driver);

    if Result then begin
      AReturnCode := 1;
    end;
  end;
end;

{
}
procedure RZDriver_Close;
begin
  if RZDriver.handle <> INVALID_HANDLE_VALUE then begin
    acDriverUtils.CloseDriver (RZDriver, true);
  end;
end;

end.
